package com.ruoyi.system.service.impl;

import java.util.List;

import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.system.mapper.ActSuppliesHistorydataMapper;
import com.ruoyi.system.domain.ActSuppliesHistorydata;
import com.ruoyi.system.service.IActSuppliesHistorydataService;

/**
 *  历史数据Service业务层处理
 * 
 * @author dongjg
 * @date 2023-08-01
 */
@Service
public class ActSuppliesHistorydataServiceImpl implements IActSuppliesHistorydataService
{
    @Autowired
    private ActSuppliesHistorydataMapper actSuppliesHistorydataMapper;

    /**
     * 查询 历史数据
     * 
     * @param id  历史数据ID
     * @return  历史数据
     */
    @Override
    public ActSuppliesHistorydata selectActSuppliesHistorydataById(Long id)
    {
        return actSuppliesHistorydataMapper.selectActSuppliesHistorydataById(id);
    }

    /**
     * 查询 历史数据列表
     * 
     * @param actSuppliesHistorydata  历史数据
     * @return  历史数据
     */
    @Override
    public List<ActSuppliesHistorydata> selectActSuppliesHistorydataList(ActSuppliesHistorydata actSuppliesHistorydata)
    {
        SysUser user = SecurityUtils.getLoginUser().getUser();
      actSuppliesHistorydata.setCreateBy(user.getUserName());
        return actSuppliesHistorydataMapper.selectActSuppliesHistorydataList(actSuppliesHistorydata);
    }

    /**
     * 新增 历史数据
     * 
     * @param actSuppliesHistorydata  历史数据
     * @return 结果
     */
    @Override
    public int insertActSuppliesHistorydata(List<ActSuppliesHistorydata> actSuppliesHistorydata)
    {

        for (int i=0;i<actSuppliesHistorydata.size();i++){

            Long status = actSuppliesHistorydata.get(i).getStatus();

        }
        return actSuppliesHistorydataMapper.insertActSuppliesHistorydata(actSuppliesHistorydata.get(0));
    }

    /**
     * 修改 历史数据
     * 
     * @param actSuppliesHistorydata  历史数据
     * @return 结果
     */
    @Override
    public int updateActSuppliesHistorydata(ActSuppliesHistorydata actSuppliesHistorydata)
    {
        return actSuppliesHistorydataMapper.updateActSuppliesHistorydata(actSuppliesHistorydata);
    }

    /**
     * 批量删除 历史数据
     * 
     * @param ids 需要删除的 历史数据ID
     * @return 结果
     */
    @Override
    public int deleteActSuppliesHistorydataByIds(Long[] ids)
    {
        return actSuppliesHistorydataMapper.deleteActSuppliesHistorydataByIds(ids);
    }

    /**
     * 删除 历史数据信息
     * 
     * @param id  历史数据ID
     * @return 结果
     */
    @Override
    public int deleteActSuppliesHistorydataById(Long id)
    {
        return actSuppliesHistorydataMapper.deleteActSuppliesHistorydataById(id);
    }

    @Override
    public int addInsertActSuppliesHistorydata(List<ActSuppliesHistorydata> actSuppliesHistorydata) {

        SysUser user = SecurityUtils.getLoginUser().getUser();
        ActSuppliesHistorydata actSuppliesHistorydata1 = new ActSuppliesHistorydata();

        Long s = actSuppliesHistorydataMapper.selectActSuppliesHistorydatauuid(actSuppliesHistorydata.get(0).getImportUuid());

        if (s>0){
            for (int i=0;i<actSuppliesHistorydata.size();i++) {
                actSuppliesHistorydata.get(i).setCreateBy(user.getUserName());
                actSuppliesHistorydata.get(i).setCreateTime(DateUtils.getNowDate());
                actSuppliesHistorydataMapper.updateActSuppliesHistorydatas(actSuppliesHistorydata.get(i));
            }
        }else {

            Long[] longs = actSuppliesHistorydataMapper.selectActSuppliesRole(actSuppliesHistorydata.get(0).getTemplateId());

            for (int i=0;i<longs.length;i++){

                actSuppliesHistorydata1.setImportUuid(actSuppliesHistorydata.get(0).getImportUuid());
                actSuppliesHistorydata1.setTemplateId(actSuppliesHistorydata.get(0).getTemplateId());
                actSuppliesHistorydata1.setRoleId(longs[i]);
                actSuppliesHistorydata1.setStatus(1L);
                actSuppliesHistorydata1.setIdentifyingCode(0L);

                actSuppliesHistorydataMapper.insertActSuppliesHistorydata(actSuppliesHistorydata1);

            }

            actSuppliesHistorydata1.setImportUuid(actSuppliesHistorydata.get(0).getImportUuid());
            actSuppliesHistorydata1.setTemplateId(actSuppliesHistorydata.get(0).getTemplateId());
            actSuppliesHistorydata1.setStatus(1L);
            actSuppliesHistorydata1.setIdentifyingCode(1L);
            actSuppliesHistorydataMapper.insertActSuppliesHistorydata(actSuppliesHistorydata1);

            for (int i=0;i<actSuppliesHistorydata.size();i++){

                actSuppliesHistorydata.get(i).setCreateBy(user.getUserName());
                actSuppliesHistorydata.get(i).setCreateTime(DateUtils.getNowDate());
                actSuppliesHistorydataMapper.updateActSuppliesHistorydatas(actSuppliesHistorydata.get(i));

            }

        }

        return 0;
    }
}
